/*---------------------------------------------------------------------------

    Filename: main.js
    Project:  Picture Puzzle
    (C) Copyright 2008, Kirix Corporation, All Rights Reserved.

    Summary:         Bootstrapper script to run the Picture Puzzle extension
    Developer(s):    Jeff Engel

---------------------------------------------------------------------------*/


include "picturepuzzle.js";
include "pictureflow/pictureflow.js";
include "utils/external.js";
include "utils/limitedtimer.js";
include "utils/tools_menu_inserter.js";



// main entry point to the program; launch the program, either immediately if
// run as as script or else install to the tools menu if run as an extension
if (Extension.isContextPackage())
{
    // program is running as an extension, install to the "Tools" menu
    var menu_item = insertToolsMenuItem("Picture Puzzle...");

    // when triggered, display the main form
    menu_item.click.connect(
        function()
        {
            var form = new PicturePuzzleGame(0, 0, 276, 318);
            form.center();
            form.show();
        });
}
 else
{
    // program is running as a script, display the form immediately
    var form = new PicturePuzzleGame(0, 0, 276, 318);
    form.center();
    form.show();
}

// start the main application loop
Application.run();
