
function makeWebpageExternal(file, basepath)
{
    if (!basepath)
        basepath = "";
    else if (basepath.charAt(basepath.length - 1) != "/")
        basepath += "/";

    var html = Extension.getTextResource(basepath + file),
        externalizers = [],
        exp = new RegExp("(?i)(.)\\bkstrata-(img|txt)://"
                       + "(.+?)\\b\\1");

    externalizers["img"] = makeBmpExternal;
    externalizers["txt"] = makeTxtExternal;


    while (exp.test(html))
    {
        var pathparts = html.match(exp);
        var tmppath = externalizers[pathparts[2]](basepath + pathparts[3]);

        if (!tmppath)
            tmppath = "";

        html = html.replace(pathparts[0],
                            pathparts[1] + "file://" + tmppath + pathparts[1]);
    }

    return html;
}


function makeBmpExternal(path)
{
    // create a temporary file path to write to
    var tmppath = File.getTempFilename() + ".png";

    // load the file's contents
    var bmp = Extension.getBitmapResource(path);
    if (bmp === null)
        return null;

    // write the file's contents to the temporary file
    if (!bmp.saveFile(tmppath, Bitmap.FormatPNG))
        return null;

    // return the temporary file path
    return tmppath;
}

function makeTxtExternal(path)
{
    // create a temporary file path to write to
    var idx = path.lastIndexOf("."),
        tmppath = File.getTempFilename();

    // append the file extension (if found)
    if(idx != -1 && path.length - idx <= 5 && path.length - idx > 2)
        tmppath += path.substr(idx);

    // load the file's contents
    var txt = Extension.getTextResource(path);
    if (txt === null)
        return null;

    // write the file's contents to the temporary file
    if (!File.createText(tmppath).write(txt))
        return null;

    // return the temporary file path
    return tmppath;
}
